'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = excerpt;

var _cliColor = require('cli-color');

var _cliColor2 = _interopRequireDefault(_cliColor);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var grey = _cliColor2.default.xtermSupported ? _cliColor2.default.xterm(241) : _cliColor2.default.blackBright;
var red = _cliColor2.default.red;
var bgWhite = _cliColor2.default.bgWhite;

function spaces(count) {
  return new Array(count).join(' ');
}

function excerpt(_ref) {
  var contents = _ref.contents;
  var line = _ref.line;
  var column = _ref.column;

  var report = [];

  // add source lines
  if (!(0, _lodash.isNil)(contents) && !(0, _lodash.isNil)(line)) {
    var lines = [];

    var sourceSplit = contents.toString().split('\n');
    var linesToShow = 8;
    var maxDigits = String(line).length + 1;

    // iterate backwards through the <=8 lines that are in the excerpt
    var l = Math.min(sourceSplit.length, line + 4) + 1;
    while (l-- > 1 && linesToShow-- > 0) {
      var digitGap = spaces(maxDigits - String(l).length);

      var numbering = '  ' + digitGap + l + ' ┃ ';
      var code = sourceSplit[l - 1];
      var text = void 0;

      if (l === line) {
        if (column) {
          code = code.substring(0, column) + bgWhite(red(code.charAt(column))) + code.substring(column + 1);
        }

        text = numbering + code;
      } else text = grey(numbering + code);

      lines.unshift(text);
    }

    report.push(lines.join('\n'));
  }

  // put it together
  return report.join('\n');
}
//# sourceMappingURL=excerpt.js.map