'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

require('babel-polyfill');

var _builtinModules = require('builtin-modules');

var _builtinModules2 = _interopRequireDefault(_builtinModules);

var _cliColor = require('cli-color');

var _cliColor2 = _interopRequireDefault(_cliColor);

var _excerpt = require('./excerpt');

var _excerpt2 = _interopRequireDefault(_excerpt);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _isAbsolute = require('is-absolute');

var _isAbsolute2 = _interopRequireDefault(_isAbsolute);

var _minimist = require('minimist');

var _minimist2 = _interopRequireDefault(_minimist);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _pathExists = require('path-exists');

var _pathExists2 = _interopRequireDefault(_pathExists);

var _readableStack = require('./readableStack');

var _readableStack2 = _interopRequireDefault(_readableStack);

var _stackTrace = require('stack-trace');

var _stackTrace2 = _interopRequireDefault(_stackTrace);

var _subdir = require('subdir');

var _subdir2 = _interopRequireDefault(_subdir);

var _module = require('module');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var flags = (0, _minimist2.default)(process.argv.slice(2));

// register babel require hook
{
  // choose optimal config for the current engine
  var presets = [require('babel-preset-stage-0'), require('babel-preset-react')];
  var nodeVersion = Number(process.versions.node.split('.')[0]);
  if (nodeVersion > 4) presets.push(require('babel-preset-es2015-node5'));else if (nodeVersion === 4) presets.push(require('babel-preset-es2015-node4'));else presets.push(require('babel-preset-es2015'));

  require('babel-register')({
    presets: presets,
    ignore: /node_modules/
  });
}

// make magic imports work
{
  (function () {
    var oldNodeModulePaths = _module.Module._nodeModulePaths;
    var esboxRoot = _path2.default.resolve(__dirname, '..', '..');
    var esboxNodeModules = _path2.default.join(esboxRoot, 'node_modules');

    _module.Module._nodeModulePaths = function _modifiedNodeModulePaths(fromWhere) {
      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      var paths = oldNodeModulePaths.call.apply(oldNodeModulePaths, [this, fromWhere].concat(args));
      paths.push(esboxNodeModules);
      return paths;
    };
  })();
}

// catch global errors and present them nicely
process.on('uncaughtException', function (error) {
  var cwd = process.cwd();

  var line = void 0;
  var column = void 0;
  var message = void 0;
  var fileName = void 0;

  if (error._babel) {
    var _error$message$split = error.message.split(': ');

    var _error$message$split2 = _slicedToArray(_error$message$split, 2);

    fileName = _error$message$split2[0];
    message = _error$message$split2[1];


    line = error.loc.line;
    column = error.loc.column;
  } else {
    var stack = _stackTrace2.default.parse(error);
    var first = stack[0];

    line = first.getLineNumber();
    column = first.getColumnNumber();
    fileName = first.getFileName();
    message = error.message;
  }

  var fileRelative = fileName && (0, _subdir2.default)(cwd, fileName) ? _path2.default.relative(cwd, fileName) : fileName || '[null]';

  if (error._babel) {
    console.log('\nCompile error: ' + fileRelative + '\n' + (0, _excerpt2.default)({
      line: line, column: column,
      contents: _fs2.default.readFileSync(fileName)
    }) + '\n' + _cliColor2.default.red(message.trim()));
  } else {
    // try to determine if it's a local file (as opposed to a builtin)
    if (fileName && ((0, _isAbsolute2.default)(fileName) || _builtinModules2.default.indexOf(_path2.default.basename(fileName, '.js')) === -1 && _pathExists2.default.sync(_path2.default.resolve(cwd, fileName)))) {
      console.log('\nRuntime error: ' + fileRelative + '\n' + (0, _excerpt2.default)({
        line: line, column: column,
        contents: _fs2.default.readFileSync(fileName)
      }) + '\n');
    }

    console.log(_cliColor2.default.red(message.trim()) + '\n' + (0, _readableStack2.default)(error) + '\n');
  }

  process.exit(1);
});

// make sure promise rejections don't get swallowed
process.on('unhandledRejection', function (reason) {
  if (reason && reason instanceof Error) throw reason;

  var error = new Error('Unhandled rejection');
  error.reason = error;
  throw error;
});

// run the user's script
require(flags.file);
//# sourceMappingURL=run.js.map